#include "allegro.h"
#include <ApplicationServices/ApplicationServices.h>
#include <iostream>
#include <math.h>
#include <vector>
#include <time.h>

//change background colour depending on performance

void init();
void deinit();

const int NONOTE=-60;
const int notecount=12*4+1;
int canon[notecount]={
0 ,
7 ,
10 ,
5 ,

7 ,
NONOTE ,
5 ,
NONOTE ,

3 ,
2 ,
7 ,
NONOTE ,

8 ,
NONOTE ,
7 ,
NONOTE ,

5 ,
2 ,
3 ,
-2 ,

-4 ,
NONOTE ,
-5 ,
-2 ,

2 ,
3 ,
2 ,
NONOTE ,

NONOTE ,
-2 ,
3 ,
7 ,

14 ,
NONOTE ,
9 ,
7 ,

6 ,
NONOTE ,
12 ,
15 ,

17 ,
9 ,
7 ,
12 ,

10 ,
12 ,
3 ,
6,

7
};

int noteindex=0;


int min(int a, int b)
{
	if (a<b) return a;
	else return b;    
}

int max(int a,int b)
{
	if (a>b)  return a;
	else return b;
}
const int pan = 128;
const int pitch = 1000;

const int playerwidth=32;


BITMAP* buffer;
BITMAP* city[5];
BITMAP* worldmap;
BITMAP* herobmp;
BITMAP* peoplebmp;

SAMPLE* hit;
SAMPLE* selectwav;
SAMPLE* wings;

/* FRAMERATE CONTROL*/


volatile unsigned int frames, fps;
void second_counter(void)
{
	fps=frames;
	frames=0;
} END_OF_FUNCTION(second_counter);
int timewaster_delay;
extern void do_prog(void);

volatile unsigned int ticks;
void ticker(void)
{
	++ticks;
} END_OF_FUNCTION(ticker);

enum GameState { gs_prefaces, gs_globe, gs_game, gs_postlude};
GameState gamestate;
int livesaved;
bool completed[5];

using namespace std;

const int spritewidth=8;
const int spriteheight=8;

const int maxvel=15;
const int maxyvel=0;
const int maxx=640-spritewidth;
const int maxy=480-spriteheight-15;

inline int lengthsq (int x, int y)
{
	return x*x+y*y;
}

int suicidepoints[5][10][2] = 
{
{
{38,127},
{161,40},
{231,252},
{257,85},
{293,4},
{340,84},
{381,123},
{437,323},
{486,80},
{614,114},
},
{
{107,195},
{186,197},
{198,18},
{240,18},
{361,150},
{399,148},
{480,198},
{517,196},
{556,276},
{595,275},
},
{
{117,38},
{145,38},
{200,157},
{299,159},
{347,15},
{463,222},
{556,222},
{525,50},
{607,221},
{138,158},
},
{
{50,64},
{111,63},
{142,19},
{219,16},
{263,7},
{365,6},
{363,76},
{453,75},
{544,139},
{593,28},
},

{
{50,127},
{101,127},
{196,36},
{234,36},
{327,165},
{390,165},
{416,101},
{477,103},
{535,193},
{612,194},
},
};

/*
 suicide points:
 
 
 city1
 50,127
 101,127
 196,36
 234,36
 327,165
 390,165
 416,101
 477,103
 535,193
 612,194
 
 
 city 2
 107,195
 186,197
 198,18
 240,18
 361,150
 399,148
 480,198
 517,196,
 556,276
 595,275
 
 city3
 117,38
 145,38
 200,157
 299,159
 347,15
 463,222
 556,222
 525,50
 607,221
 138,158
 
 city4
 50,64
 111,63
 142,19
 219,16
 263,7
 365,6
 363,76
 453,75
 544,139
 593,28
 
 city5
 38,127
 161,40
 231,252
 257,85
 293,4
 340,84
 381,123
 437,323
 486,80
 614,114
 
 */

int main() {
	
    int mpx=30;
	int mpy=30;
	int mvx=0;
	int mvy=0;
	
	int px=30;
	int py=30;
	int vx=0;
	int vy=0;
	
	const int entcount=16;
	
	int ex[entcount];
	int ey[entcount];
	int evelx[entcount];
	int evely[entcount];
	int esprite[entcount];
	
	int score=0;
	int statetimer=0;
	int playtimer=0;
	int prefacescreen=0;
	bool spaceup=true;
	int brightness=0;
	bool atpeace=false;
	
	const int PARTICLECOUNT=25;
	int particlepos[PARTICLECOUNT][2];
	int curparticle=0;
	
	init();
	
	bool quit=false;
	
	int level;
	
	while (!key[KEY_ESC]&&!quit) 
	{
		clear_bitmap(buffer);
		int t = 255*score / notecount;
		clear_to_color(buffer, makecol(t,t,t));
			
		switch (gamestate)
		{
			case gs_prefaces:
				if (statetimer>-10)
				{
					if (statetimer<84)
						statetimer+=2;
					else
					{
						if (prefacescreen==2)
						{
							statetimer=-100;
							spaceup=false;
						}
					}

					clear_to_color(buffer,makecol(255,255,255));
					switch (prefacescreen)
					{
						case 0:
							textout_ex(buffer, font, "increpare presents", 100, 16, makecol(0,0,0),makecol(255,255,255));
							break;
						case 1:
							textout_ex(buffer, font, "The Hero Saved Me", 100, 16, makecol(0,0,0),makecol(255,255,255));
							break;
						case 2:
							break;
						case 3:
							textout_ex(buffer, font, "I hear", 100, 16, makecol(0,0,0),makecol(255,255,255));
							textout_ex(buffer, font, "so many people.", 100, 30, makecol(0,0,0),makecol(255,255,255));
							break;
						case 4:
							textout_ex(buffer, font, "They cry out", 100, 16, makecol(0,0,0),makecol(255,255,255));
							textout_ex(buffer, font, "to be saved.", 100, 30, makecol(0,0,0),makecol(255,255,255));
							break;
					}
					if (key[KEY_SPACE])
					{
						if (spaceup)
						{
							statetimer=-100;
							spaceup=false;
						}
					}
					else
						spaceup=true;
						
						
				}
				else
				{
					if (prefacescreen<4)
					{
						prefacescreen++;
						statetimer=0;
					}
					else
					{
						gamestate=gs_globe;
						play_sample(selectwav, 255, pan,1000, 0);
						statetimer=-50;
						spaceup=false;
						mpx=160;
						mpy=160;
					}
				}
				break;
			case gs_globe:
			{
				if (key[KEY_LEFT])
				{
					if (mvx<=0&&mvx>-5&&mvy==0)
						mvx=-5;
					else
						mvx-=1;
				}
				if (key[KEY_RIGHT])
				{
					if (mvx>=0&&mvx<5&&mvy==0)
						mvx=5;
					else
						mvx+=1;
				}
				if (key[KEY_UP])
				{
					if (mvy<=0&&mvy>-5&&mvx==0)
						mvy=-5;
					else
						mvy-=1;
				}
				if (key[KEY_DOWN])
				{
					if (mvy>=0&&mvy<5&&mvx==0)
						mvy=5;
					else
						mvy+=1;
				}
				
				if (!(key[KEY_LEFT]||key[KEY_RIGHT]))
				{
					mvx=0;
				}
				
				if (!(key[KEY_UP]||key[KEY_DOWN]))
				{
					mvy=0;
				}
				
				while (lengthsq(mvx,mvy)>(maxvel*maxvel))
				{
					if (mvx>0)
						mvx--;
					else if (mvx<0)
						mvx++;
					
					if (mvy>0)
						mvy--;
					else if (mvy<0)
						mvy++;
				}
				
				mpx+=mvx;
				mpy+=mvy;
				
				if (mpx<0)
				{
					mpx=0;
					mvx=0;
				}
				else if(mpx>maxx)
				{
					mpx=maxx;
					mvx=0;
				}
				
				if (mpy<0)
				{
					mpy=0;
					mvy=0;
				}
				else if(mpy>maxy)
				{
					mpy=maxy;
					mvy=0;
				}
				
			
				blit(worldmap, buffer, 0, 0, 0, 63, 640, 354);
				
				int curpixel=getpixel(buffer, mpx, mpy);
				int selected;
				
				if (curpixel==getpixel(worldmap,83,90))
				{//north america
					textout_ex(buffer,font,"New York",473,235+63,makecol(255,255,255),makecol(0,0,0));
					selected=0;
				}
				else if (curpixel==getpixel(worldmap,168,234))
				{//south america
					textout_ex(buffer,font,"Sao Paulo",473,235+63,makecol(255,255,255),makecol(0,0,0));	
					selected=1;
				}
				else if (curpixel==getpixel(worldmap,346,78))
				{
					textout_ex(buffer,font,"London",473,235+63,makecol(255,255,255),makecol(0,0,0));	
					selected=2;
				}
				else if (curpixel==getpixel(worldmap,307,157))
				{
					textout_ex(buffer,font,"Johannesburg",473,235+63,makecol(255,255,255),makecol(0,0,0));
					selected=3;
				}
				else if (curpixel==getpixel(worldmap,416,85))
				{
					textout_ex(buffer,font,"Tokyo",473,235+63,makecol(255,255,255),makecol(0,0,0));		
					selected=4;
				}
				else
				{
					textout_ex(buffer,font,"International Waters",473,235+63,makecol(255,255,255),makecol(0,0,0));
					selected=5;
				}
				
				if (selected!=5)
					if (completed[selected])
						textout_ex(buffer,font,"At peace",473+3,235+63+16,makecol(255,255,255),makecol(0,0,0));
					else
						textout_ex(buffer,font,"Anguished",473+3,235+63+16,makecol(255,255,255),makecol(0,0,0));

				
				masked_blit(herobmp,buffer,(vx<0?0:(vx>0?16:8)),8*(vy>0),mpx,mpy,spritewidth,spriteheight);
//				rectfill(buffer, px, py, px+spritewidth-1, py+spriteheight-1, makecol(0,0,255));
				statetimer++;

				if (key[KEY_SPACE])
				{

					if (statetimer>0&&selected!=5&&!completed[selected])
					{
						px=160;
						py=160;
						vx=0;
						vy=0;
						

						
						gamestate=gs_game;
						level=selected;
						play_sample(selectwav, 255, pan,1000, 0);
						
						for (int i=0;i<entcount;i++)
						{
						int newpos=rand()%10;
						ex[i]=suicidepoints[level][newpos][0];
						ey[i]=suicidepoints[level][newpos][1];
						evely[i]=0;
						evelx[i]=0;
						esprite[i]=rand()%4;
						}
						
						for (int i=0;i<PARTICLECOUNT;i++)
						{
							particlepos[i][0]=px+4;
							particlepos[i][1]=py+4;
						}
						curparticle=0;
						
						spaceup=false;
					}
				}
				else
					spaceup=true;
			}
				break;
			case gs_game:

				
				if (key[KEY_LEFT])
				{
					if (vx<=0&&vx>-5&&vy==0)
						vx=-5;
					else
						vx-=1;
				}
				if (key[KEY_RIGHT])
				{
					if (vx>=0&&vx<5&&vy==0)
						vx=5;
					else
						vx+=1;
				}
				if (key[KEY_UP])
				{
					if (vy<=0&&vy>-5&&vx==0)
						vy=-5;
					else
						vy-=1;
				}
				if (key[KEY_DOWN])
				{
					if (vy>=0&&vy<5&&vx==0)
						vy=5;
					else
						vy+=1;
				}
				
				if (!(key[KEY_LEFT]||key[KEY_RIGHT]))
				{
					if (vx>0)
						vx--;
					else if (vx<0)
						vx++;
				}
				
				if (!(key[KEY_UP]||key[KEY_DOWN]))
				{
					if (vy>0)
						vy--;
					else if (vy<0)
						vy++;
				}
				
				while (lengthsq(vx,vy)>(maxvel*maxvel))
				{
					if (vx>0)
						vx--;
					else if (vx<0)
						vx++;
						
					if (vy>0)
						vy--;
					else if (vy<0)
						vy++;
				}
				
				curparticle=(curparticle+1)%PARTICLECOUNT;
				particlepos[curparticle][0]=px+4;
				particlepos[curparticle][1]=py+4;
				
				px+=vx;
				py+=vy;
				
				if (px<0)
				{
					px=0;
					vx=0;
				}
				else if(px>maxx)
				{
					px=maxx;
					vx=0;
				}
				
				if (py<0)
				{
					py=0;
					vy=0;
				}
				else if(py>maxy)
				{
					py=maxy;
					vy=0;
				}
				
				
				blit(city[level],buffer,0,0,0,0,640,480);
	
				for (int i=(curparticle+1)%PARTICLECOUNT;i!=curparticle;i=(i+1)%PARTICLECOUNT)
				{
					line(buffer, particlepos[i][0], particlepos[i][1], particlepos[(i+1)%PARTICLECOUNT][0],  particlepos[(i+1)%PARTICLECOUNT][1], makecol(brightness/2,brightness/2,brightness/2));
					putpixel(buffer, particlepos[i][0], particlepos[i][1], makecol(brightness,brightness,brightness));
					brightness+=5;
				}
				brightness=0;
			
				masked_blit(herobmp,buffer,(vx<0?0:(vx>0?16:8)),8*(vy>0),px,py,spritewidth,spriteheight);
				
				
				atpeace=true;
				for (int i=0;i<entcount;i++)
				{
					if (esprite[i]!=4)
					{
					atpeace=false;
					evely[i]++;
					ey[i]+=evely[i]/4;
					ex[i]+=evelx[i];
					
					
					for (int j=0;j<PARTICLECOUNT;j++)
					{
						if (lengthsq(ex[i]-particlepos[j][0],ey[i]-particlepos[j][1])<8*8)
						{
							esprite[i]=4;
							play_sample(wings, 255, pan,1000, 0);
						}
					}
						
						if (ey[i]>maxy)
						{
							play_sample(hit, 255, pan,1000, 0);
							putpixel(city[level],ex[i],465,makecol(255,0,0));
							putpixel(city[level],ex[i]+1,465,makecol(255,0,0));
							putpixel(city[level],ex[i]+2,465,makecol(255,0,0));
							putpixel(city[level],ex[i]+3,465,makecol(255,0,0));
							putpixel(city[level],ex[i]+4,465,makecol(255,0,0));
							putpixel(city[level],ex[i]+5,465,makecol(255,0,0));
							putpixel(city[level],ex[i]+6,465,makecol(255,0,0));
							putpixel(city[level],ex[i]+7,465,makecol(255,0,0));
							
							int newpos=rand()%10;
							ex[i]=suicidepoints[level][newpos][0];
							ey[i]=suicidepoints[level][newpos][1];
							evely[i]=0;
							evelx[i]=0;
							esprite[i]=rand()%4;
						}

						
					}
					else
					{
						ey[i]--;
						if (ey[i]<-8)
						{
							int newpos=rand()%10;
							ex[i]=suicidepoints[level][newpos][0];
							ey[i]=suicidepoints[level][newpos][1];
							evely[i]=0;
							evelx[i]=0;
							esprite[i]=rand()%4;
						}
					}
					
									
					masked_blit(peoplebmp,buffer,8*esprite[i],0,ex[i],ey[i],spritewidth,spriteheight);
					
				}
				if (atpeace)
				{
					gamestate=gs_postlude;
					completed[level]=true;
					play_sample(selectwav, 255, pan,1000, 0);
				}
				
//				rectfill(buffer, ex, ey, ex+spritewidth-1, ey+spriteheight-1, makecol(0,255,0));

				
				if (key[KEY_SPACE])
				{
					if (spaceup)
					{
						gamestate=gs_globe;
						play_sample(selectwav, 255, pan,1000, 0);
						px=160;
						py=160;
						vx=0;
						vy=0;
						statetimer=-50;
						spaceup=false;
					}
				}
				else
					spaceup=true;
				
				break;
			case gs_postlude:
					switch (level)
					{
						case 0:
							textout_ex(buffer, font, "And so did I bring peace", 100, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "to the souls of that tragic city.", 100, 44, makecol(255,255,255),makecol(0,0,0));
							break;
						case 1:
							textout_ex(buffer, font, "The last of them died in my arms.", 100, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "\"Thank you\", she said \"for bringing me hope at the moment of my death.\"",100, 30, makecol(255,255,255),makecol(0,0,0));
							break;
						case 2:
							textout_ex(buffer, font, "When I found I had the power to bring death",100, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "I thought the world was cruel.",100, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "But it is precisely the cruelty of the world,",100, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "that allows my curse to function as a gift.",100, 58, makecol(255,255,255),makecol(0,0,0));
							break;
						case 3:
							textout_ex(buffer, font, "Only one was unhappy;",100, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "he did not need my gift.",100, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "I let him drop to the pavement,",100, 44, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "my hopes returned.",100, 58, makecol(255,255,255),makecol(0,0,0));
							break;
						case 4:
							textout_ex(buffer, font, "I have never seen an angel fall from heaven,",100, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "only from these skyscrapers and tenements.",100, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "What do we know that they don't?",100, 44, makecol(255,255,255),makecol(0,0,0));
							break;
						case 5:
							textout_ex(buffer, font, "When it was all over I thought to myself,",100, 16, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "I wondered what it must be like to commit suicide.",100, 30, makecol(255,255,255),makecol(0,0,0));
							textout_ex(buffer, font, "What must it be like to commit suicide?",100, 44, makecol(255,255,255),makecol(0,0,0));
							break;
					}
					if (key[KEY_SPACE])
					{							
						if (spaceup)
						{
							bool completedall=true;
							for (int i=0;i<5;i++)
								if (!completed[i])
									completedall=false;
							
							if (completedall)
							{
								if (level<5)
									level=5;
								else
								{
									quit=true;
								}
							}
							else
							{
							gamestate=gs_globe;
								statetimer=-50;
							play_sample(selectwav, 255, pan,1000, 0);
							px=160;
							py=160;
							vx=0;
							vy=0;
							}
							spaceup=false;
						}
					}
					else
						spaceup=true;
				break;
		}
			
				
		/* control timing */
		while (ticks<1)
		{
			rest(0);
		}
		ticks=0;
		++frames;
		
		stretch_blit(buffer, screen, 0, 0, 640, 480, 0,0,640, 480);		
	}	
	
	
	deinit();
	return 0;
}
END_OF_MAIN()

void init() {
	int depth, res;
	allegro_init();
	depth = desktop_color_depth();
	if (depth == 0) depth = 32;
	set_color_depth(depth);
	res = set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0);
	if (res != 0) {
		allegro_message(allegro_error);
		exit(-1);
	}
	
	for (int i=0;i<5;i++)
		completed[i]=0;
	
	srand ( time(NULL) );
	
	CGDisplayHideCursor(kCGDirectMainDisplay);
	
	install_timer();
	install_keyboard();
	install_mouse();
	
	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	
	          
	worldmap=load_bitmap("worldmap.bmp", NULL);
	
	city[0]=load_bitmap("city1.bmp",NULL);
	city[1]=load_bitmap("city2.bmp",NULL);
	city[2]=load_bitmap("city3.bmp",NULL);
	city[3]=load_bitmap("city4.bmp",NULL);
	city[4]=load_bitmap("city5.bmp",NULL);
	
	herobmp=load_bitmap("hero.bmp",NULL);
	peoplebmp=load_bitmap("people.bmp",NULL);
	
	hit=load_sample("hit.wav");
	wings=load_sample("wings.wav");
	selectwav=load_sample("select.wav");
	
	LOCK_FUNCTION(second_counter);
	LOCK_VARIABLE(fps);
	LOCK_VARIABLE(frames);
	LOCK_FUNCTION(ticker);
	LOCK_VARIABLE(ticks);
	
	
	frames=timewaster_delay=0;
	install_int_ex(second_counter, BPS_TO_TIMER(1));
	install_int_ex(ticker, BPS_TO_TIMER(30));
	
	
	
	buffer=create_bitmap(640,480);
	//        bg=create_bitmap(800,600);        
	
}

void deinit() {
	clear_keybuf();
	/* add other deinitializations here */
}
